#include <iomanip.h>
#include <iostream.h>
#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "Server.H"

int GetConf (Server &kom, char *name, char f)
{
  Token *token;
  
  kom.Command (Server_LookupZName, name, 1, f);
  token = kom.Read ();
  
  switch (token->Array (0)->Number ())
    {
    case 0:
      cerr << "No match for " << name << endl;
      return -1;

    case 1:
      int n;
      n = token->Array (1)->Array (2)->Number ();
      delete token;
      return n;
      
    default:
      int cntr = 0;
      cerr << "Multiple matches for " << name << endl;
      while (cntr < token->Array (0)->Number ())
	{
	  cerr << token->Array (1)->Array (cntr * 3)->String () << endl;
	  cntr++;
	}
      return -1;
    }
}

Token *GetTextdata (Server &kom, int conf)
{
  kom.Command (Server_GetConfStat, conf);
  Token *stat = kom.Read ();
  
  kom.Command (Server_LocalToGlobal, conf, 1, stat->Array (30)->Number ());
  Token *txts = kom.Read ();
  
  delete stat;
  return txts;
}

void Login (Server &kom, int pers)
{
  Token *token;
  char *pass;
  pass = getpass ("Password: ");
  if (pass == NULL || strlen (pass) == 0)
    {
      cerr << "No password. Quitting." << endl;
      exit (EXIT_SUCCESS);
    }
  kom.Command (Server_Login, pers, pass, 1);
  token = kom.Read ();
  delete token;
}

int main (int argc, char **argv)
{
  if (argc < 4)
    {
      cerr << "komgrep version " << VERSION << endl;
      cerr << "Usage: " << argv[0] << " USERNAME PATTERN CONFERENCE" << endl;
      return EXIT_FAILURE;
    }
  
  Server kom ("kom.lysator.liu.se");
  
  kom.Command (Server_InitProtocol, argv[1], NULL);
  
  int pers = GetConf (kom, argv[1], 0);
  if (pers < 0) return EXIT_FAILURE;
  
  Login (kom, pers);
  
  int conf = GetConf (kom, argv[3], 1);
  if (conf < 0) return EXIT_FAILURE;
  
  int tc = 1;
  int cnt;
  int dns;
  int max;
  int txtnr;
  
  Token *txts;
  do
    {
      kom.Command (Server_LocalToGlobal, conf, tc, 255);
      txts = kom.Read ();
      cnt = txts->Array (2)->Number ();
      dns = txts->Array (3)->Number ();
      max = txts->Array ( dns ? 5 : 4)->Number ();

      int cntr = 0;
      while (cntr < max)
	{
	  txtnr = txts->Array (dns ? 6 : 5)->
	    Array (cntr * (dns ? 1 : 2) + (dns ? 0 : 1))->Number ();
	  if (txtnr)
	    {
	      cerr << setw (8) << txtnr << "\r";
	      kom.Command (Server_GetText, txtnr, 0, INT_MAX);
	      Token *txt = kom.Read ();
	      char *p;
	      p = txt->Array (0)->String ();
	      while (*p)
		{
		  if (*p == '\n') *p = ' ';
		  p++;
		}
	      char buf[70];
	      if (p = strstr (txt->Array (0)->String (), argv[2]))
		{
		  p -= 30 - strlen (argv[2]) / 2;
		  if (p < txt->Array (0)->String ())
		    p = txt->Array (0)->String ();
		  strncpy (buf, p, 65);
		  buf[65] = '\0';
		  cout << setw (8) << txtnr;
		  cout << ": " << buf << endl;
		}
	    }
	  cntr++;
	}
      tc = txts->Array (1)->Number ();
      delete txts;
    }
  while (cnt);
}
